/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
/*!
 *  \file   toppers/output_file.hpp
 *  \brief  ϥե򰷤
 *
 *  Υե륯饹
 *  \code
 *  class output_file;
 *  \endcode
 */
#ifndef TOPPERS_OUTPUT_FILE_HPP_
#define TOPPERS_OUTPUT_FILE_HPP_

#include <ostream>
#include <string>
#include "toppers/config.hpp"

namespace toppers
{

  /*!
   *  \class  output_file output_file.hpp "toppers/output_file.hpp"
   *  \brief  ϥե饹
   */
  class output_file
  {
  public:
    output_file() : omode_( static_cast< std::ios_base::openmode >( 0 ) ) {}
    output_file( std::string const& filename, std::ios_base::openmode omode )
      : filename_( filename ), omode_( omode ), enable_( true ) {}
    virtual ~output_file() {}

    std::ostream& ostr() const;
    std::string const& file_name() const { return filename_; }
    bool is_enable() const { return enable_; }
    void enable( bool flag = true ) { enable_ = flag; }
    void push_back( char c )
    {
      if ( enable_ )
      {
        ostr() << c;
      }
    }

    static std::string path_name( std::string const& filename );
    static std::string get_file_data( std::string const& filename );
    static bool set_file_data( std::string const& filename, std::string const& data );
    static bool clear_file_data( std::string const& filename );
    static void save();
  private:
    std::string filename_;
    std::ios_base::openmode omode_;
    bool enable_;
  };

  template < typename T >
    inline output_file const& operator << ( output_file const& ofile, T const& value )
  {
    if ( ofile.is_enable() )
    {
      ofile.ostr() << value;
    }
    return ofile;
  }

}

#endif  // ! TOPPERS_OUTPUT_FILE_HPP_
